Index: /palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4576)
+++ /palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4577)
@@ -1,23 +1,23 @@
 !> @file surface_data_output_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+!
 !
 ! Current revisions:
-! ------------------
+! -----------------
 ! 
 ! 
@@ -25,19 +25,22 @@
 ! -----------------
 ! $Id$
-! Added surface albedo and emissivity, which are defined using
-! the tile approach
-! 
+! File re-formatted to follow the PALM coding standard
+!
+!
+! 4547 2020-05-27 09:05:24Z moh.hefny
+! Added surface albedo and emissivity, which are defined using the tile approach
+!
 ! 4535 2020-05-15 12:07:23Z raasch
-! bugfix for restart data format query
-! 
+! Bugfix for restart data format query
+!
 ! 4535 2020-05-15 12:07:23Z raasch
-! bugfix for restart data format query
-! 
+! Bugfix for restart data format query
+!
 ! 4517 2020-05-03 14:29:30Z raasch
-! added restart with MPI-IO for reading local arrays
-! 
+! Added restart with MPI-IO for reading local arrays
+!
 ! 4502 2020-04-17 16:14:16Z schwenkel
 ! Implementation of ice microphysics
-! 
+!
 ! 4500 2020-04-17 10:12:45Z suehring
 ! - Correct output of ground/wall heat flux at USM surfaces
@@ -45,28 +48,27 @@
 !
 ! 4495 2020-04-13 20:11:20Z raasch
-! restart data handling with MPI-IO added
-! 
+! Restart data handling with MPI-IO added
+!
 ! 4444 2020-03-05 15:59:50Z raasch
-! bugfix: cpp-directives for serial mode added
-! 
+! Bugfix: cpp-directives for serial mode added
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! Fix wrongly declared nc_stat variable in surface_data_output_mod
-! 
+!
 ! 4205 2019-08-30 13:25:00Z suehring
 ! - Correct x,y-coordinates of vertical surfaces in netcdf output
 ! - Change definition of azimuth angle, reference is north 0 degree
-! - zenith angle is always defined, also for vertical surfaces where it is 
-!   90 degree, while azimuth angle is only defined for vertical surfaces, not
-!   for horizontal ones
-! 
+! - Zenith angle is always defined, also for vertical surfaces where it is 90 degree, while azimuth
+!   angle is only defined for vertical surfaces, not for horizontal ones
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4129 2019-07-31 12:56:07Z gronemeier
-! - bugfix: corrected loop over horizontal default surfaces
-! - change default setting of to_vtk and to_netcdf
+! - Bugfix: corrected loop over horizontal default surfaces
+! - Change default setting of to_vtk and to_netcdf
 !
 ! 4029 2019-06-14 14:04:35Z raasch
-! netcdf variable NF90_NOFILL is used as argument instead of "1" in call to NF90_DEF_VAR_FILL
+! Netcdf variable NF90_NOFILL is used as argument instead of "1" in call to NF90_DEF_VAR_FILL
 !
 ! 3881 2019-04-10 09:31:22Z suehring
@@ -77,9 +79,9 @@
 !
 ! 3766 2019-02-26 16:23:41Z raasch
-! bugfix in surface_data_output_rrd_local (variable k removed)
+! Bugfix in surface_data_output_rrd_local (variable k removed)
 !
 ! 3762 2019-02-25 16:54:16Z suehring
-! Remove unused variables and add preprocessor directives for variables that
-! are used only when netcdf4 is defined
+! Remove unused variables and add preprocessor directives for variables that are used only when
+! netcdf4 is defined
 !
 ! 3745 2019-02-15 18:57:56Z suehring
@@ -87,10 +89,9 @@
 !
 ! 3744 2019-02-15 18:38:58Z suehring
-! Add azimuth and zenith to output file; set long-name attributes;
-! clean-up coding layout
+! Add azimuth and zenith to output file; set long-name attributes; clean-up coding layout
 !
 ! 3735 2019-02-12 09:52:40Z suehring
-! - Split initialization into initialization of arrays and further initialization
-!   in order to enable reading of restart data.
+! - Split initialization into initialization of arrays and further initialization in order to enable
+!   reading of restart data.
 ! - Consider restarts in surface data averaging.
 ! - Correct error message numbers
@@ -115,4 +116,5 @@
 ! @author Klaus Ketelsen, Matthias Suehring, Tobias Gronemeier
 !
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -120,5 +122,5 @@
 !>
 !> @todo Create namelist file for post-processing tool.
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 
 MODULE surface_data_output_mod
@@ -134,14 +136,25 @@
 
    USE control_parameters,                                                                         &
-       ONLY:  coupling_char, data_output_during_spinup, end_time,                                  &
+       ONLY:  coupling_char,                                                                       &
+              data_output_during_spinup,                                                           &
+              end_time,                                                                            &
               message_string,                                                                      &
-              restart_data_format_output, run_description_header, simulated_time_at_begin,         &
-              spinup_time, surface_output
-
-   USE grid_variables,                                                         &
-       ONLY: dx,dy
-
-   USE indices,                                                                &
-       ONLY: nxl, nxr, nys, nyn, nzb, nzt
+              restart_data_format_output,                                                          &
+              run_description_header,                                                              &
+              simulated_time_at_begin,                                                             &
+              spinup_time,                                                                         &
+              surface_output
+
+   USE grid_variables,                                                                             &
+       ONLY: dx,                                                                                   &
+             dy
+
+   USE indices,                                                                                    &
+       ONLY: nxl,                                                                                  &
+             nxr,                                                                                  &
+             nys,                                                                                  &
+             nyn,                                                                                  &
+             nzb,                                                                                  &
+             nzt
 
 #if defined( __netcdf )
@@ -149,16 +162,23 @@
 #endif
 
-   USE netcdf_data_input_mod,                                                  &
+   USE netcdf_data_input_mod,                                                                      &
        ONLY:  init_model
 
-   USE netcdf_interface,                                                       &
-       ONLY:  nc_stat, netcdf_create_att, netcdf_create_dim,                   &
-              netcdf_create_file, netcdf_create_global_atts,                   &
-              netcdf_create_var, netcdf_data_format, netcdf_handle_error
+   USE netcdf_interface,                                                                           &
+       ONLY:  nc_stat,                                                                             &
+              netcdf_create_att,                                                                   &
+              netcdf_create_dim,                                                                   &
+              netcdf_create_file,                                                                  &
+              netcdf_create_global_atts,                                                           &
+              netcdf_create_var,                                                                   &
+              netcdf_data_format,                                                                  &
+              netcdf_handle_error
 
    USE pegrid
 
    USE restart_data_mpi_io_mod,                                                                    &
-       ONLY:  rd_mpi_io_check_array, rrd_mpi_io, wrd_mpi_io
+       ONLY:  rd_mpi_io_check_array,                                                               &
+              rrd_mpi_io,                                                                          &
+              wrd_mpi_io
 
    USE surface_mod,                                                                                &
@@ -182,63 +202,64 @@
       INTEGER(iwp) ::  npoints_total  !< total number of points / vertices which define a surface element
 
-      INTEGER(iwp), DIMENSION(:), ALLOCATABLE   ::  s        !< coordinate for NetCDF output, number of the surface element
-
-      REAL(wp) ::  fillvalue = -9999.0_wp !< fillvalue for surface elements which are not defined
-
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  azimuth  !< azimuth orientation coordinate for NetCDF output
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  es_utm   !< E-UTM coordinate for NetCDF output
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  ns_utm   !< E-UTM coordinate for NetCDF output
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  xs       !< x-coordinate for NetCDF output
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  ys       !< y-coordinate for NetCDF output
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  zs       !< z-coordinate for NetCDF output
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  zenith   !< zenith orientation coordinate for NetCDF output
-      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  var_out  !< output variables
-      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  var_av   !< variables used for averaging
-      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  points   !< points  / vertices of a surface element
-      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  polygons !< polygon data of a surface element
+      INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  s  !< coordinate for NetCDF output, number of the surface element
+
+      REAL(wp) ::  fillvalue = -9999.0_wp  !< fillvalue for surface elements which are not defined
+
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  azimuth   !< azimuth orientation coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  es_utm    !< E-UTM coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  ns_utm    !< E-UTM coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  xs        !< x-coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  ys        !< y-coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  zs        !< z-coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  zenith    !< zenith orientation coordinate for NetCDF output
+      REAL(wp), DIMENSION(:), ALLOCATABLE   ::  var_out   !< output variables
+      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  var_av    !< variables used for averaging
+      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  points    !< points  / vertices of a surface element
+      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  polygons  !< polygon data of a surface element
    END TYPE surf_out
 
-   CHARACTER(LEN=100), DIMENSION(300)       ::  data_output_surf = ' '  !< namelist variable which describes the output variables
-   CHARACTER(LEN=100), DIMENSION(0:1,300)   ::  dosurf = ' '            !< internal variable which describes the output variables
-                                                                        !<  and separates averaged from non-averaged output
-   CHARACTER(LEN=100), DIMENSION(0:1,300)   ::  dosurf_unit = ' '       !< internal variable which holds the unit of the given output variable
-
-   INTEGER(iwp) ::  average_count_surf = 0   !< number of ensemble members used for averaging
-   INTEGER(iwp) ::  dosurf_no(0:1) = 0       !< number of surface output quantities
+   CHARACTER(LEN=100), DIMENSION(300)     ::  data_output_surf = ' '  !< namelist variable which describes the output variables
+   CHARACTER(LEN=100), DIMENSION(0:1,300) ::  dosurf = ' '            !< internal variable which describes the output variables
+                                                                      !< and separates averaged from non-averaged output
+   CHARACTER(LEN=100), DIMENSION(0:1,300) ::  dosurf_unit = ' '       !< internal variable which holds the unit of the given output
+                                                                      !< variable
+
+   INTEGER(iwp) ::  average_count_surf = 0  !< number of ensemble members used for averaging
+   INTEGER(iwp) ::  dosurf_no(0:1)     = 0  !< number of surface output quantities
 #if defined( __netcdf4_parallel )
-   INTEGER(iwp) ::  oldmode                  !< save old set-fill-mode of netcdf file (not needed, but required for routine call)
-
-   INTEGER(iwp), DIMENSION(0:1) ::  dosurf_time_count = 0 !< count of output time steps
-   INTEGER(iwp), DIMENSION(0:1) ::  id_dim_s_surf         !< netcdf ID for dimension s
-   INTEGER(iwp), DIMENSION(0:1) ::  id_dim_time_surf      !< netcdf ID for dimension time
-   INTEGER(iwp), DIMENSION(0:1) ::  id_set_surf           !< netcdf ID for file
-   INTEGER(iwp), DIMENSION(0:1) ::  id_var_azimuth_surf   !< netcdf ID for variable azimuth
-   INTEGER(iwp), DIMENSION(0:1) ::  id_var_etum_surf      !< netcdf ID for variable Es_UTM
-   INTEGER(iwp), DIMENSION(0:1) ::  id_var_nutm_surf      !< netcdf ID for variable Ns_UTM
-   INTEGER(iwp), DIMENSION(0:1) ::  id_var_time_surf      !< netcdf ID for variable time
-   INTEGER(iwp), DIMENSION(0:1) ::  id_var_s_surf         !< netcdf ID for variable s
-   INTEGER(iwp), DIMENSION(0:1) ::  id_var_xs_surf        !< netcdf ID for variable xs
-   INTEGER(iwp), DIMENSION(0:1) ::  id_var_ys_surf        !< netcdf ID for variable ys
-   INTEGER(iwp), DIMENSION(0:1) ::  id_var_zenith_surf    !< netcdf ID for variable zenith
-   INTEGER(iwp), DIMENSION(0:1) ::  id_var_zs_surf        !< netcdf ID for variable zs
-   INTEGER(iwp), DIMENSION(0:1) ::  ntdim_surf            !< number of output time steps
-
-   INTEGER(iwp), DIMENSION(0:1,300) ::  id_var_dosurf     !< netcdf ID for output variables
+   INTEGER(iwp) ::  oldmode                 !< save old set-fill-mode of netcdf file (not needed, but required for routine call)
+
+   INTEGER(iwp), DIMENSION(0:1) ::  dosurf_time_count = 0  !< count of output time steps
+   INTEGER(iwp), DIMENSION(0:1) ::  id_dim_s_surf          !< netcdf ID for dimension s
+   INTEGER(iwp), DIMENSION(0:1) ::  id_dim_time_surf       !< netcdf ID for dimension time
+   INTEGER(iwp), DIMENSION(0:1) ::  id_set_surf            !< netcdf ID for file
+   INTEGER(iwp), DIMENSION(0:1) ::  id_var_azimuth_surf    !< netcdf ID for variable azimuth
+   INTEGER(iwp), DIMENSION(0:1) ::  id_var_etum_surf       !< netcdf ID for variable Es_UTM
+   INTEGER(iwp), DIMENSION(0:1) ::  id_var_nutm_surf       !< netcdf ID for variable Ns_UTM
+   INTEGER(iwp), DIMENSION(0:1) ::  id_var_time_surf       !< netcdf ID for variable time
+   INTEGER(iwp), DIMENSION(0:1) ::  id_var_s_surf          !< netcdf ID for variable s
+   INTEGER(iwp), DIMENSION(0:1) ::  id_var_xs_surf         !< netcdf ID for variable xs
+   INTEGER(iwp), DIMENSION(0:1) ::  id_var_ys_surf         !< netcdf ID for variable ys
+   INTEGER(iwp), DIMENSION(0:1) ::  id_var_zenith_surf     !< netcdf ID for variable zenith
+   INTEGER(iwp), DIMENSION(0:1) ::  id_var_zs_surf         !< netcdf ID for variable zs
+   INTEGER(iwp), DIMENSION(0:1) ::  ntdim_surf             !< number of output time steps
+
+   INTEGER(iwp), DIMENSION(0:1,300) ::  id_var_dosurf      !< netcdf ID for output variables
 #endif
 
-   LOGICAL :: first_output(0:1) = .FALSE.                 !< true if first output was already called
-   LOGICAL :: to_netcdf = .FALSE.                         !< flag indicating parallel NetCDF output
-   LOGICAL :: to_vtk = .FALSE.                            !< flag indicating binary surface-data output that can be further
-                                                          !< processed to VTK format
-
-   REAL(wp) ::  averaging_interval_surf  = 9999999.9_wp   !< averaging interval
-   REAL(wp) ::  dt_dosurf = 9999999.9_wp                  !< time interval for instantaneous data output
-   REAL(wp) ::  dt_dosurf_av = 9999999.9_wp               !< time interval for averaged data output
-   REAL(wp) ::  skip_time_dosurf = 0.0_wp                 !< skip time for instantaneous data output
-   REAL(wp) ::  skip_time_dosurf_av = 0.0_wp              !< skip time for averaged data output
-   REAL(wp) ::  time_dosurf = 0.0_wp                      !< internal counter variable to check for instantaneous data output
-   REAL(wp) ::  time_dosurf_av = 0.0_wp                   !< internal counter variable to check for averaged data output
-
-   TYPE(surf_out) ::  surfaces      !< variable which contains all required output information
+   LOGICAL ::  first_output(0:1) = .FALSE.  !< true if first output was already called
+   LOGICAL ::  to_netcdf         = .FALSE.  !< flag indicating parallel NetCDF output
+   LOGICAL ::  to_vtk            = .FALSE.  !< flag indicating binary surface-data output that can be further
+                                            !< processed to VTK format
+
+   REAL(wp) ::  averaging_interval_surf  = 9999999.9_wp  !< averaging interval
+   REAL(wp) ::  dt_dosurf                = 9999999.9_wp  !< time interval for instantaneous data output
+   REAL(wp) ::  dt_dosurf_av             = 9999999.9_wp  !< time interval for averaged data output
+   REAL(wp) ::  skip_time_dosurf         = 0.0_wp        !< skip time for instantaneous data output
+   REAL(wp) ::  skip_time_dosurf_av      = 0.0_wp        !< skip time for averaged data output
+   REAL(wp) ::  time_dosurf              = 0.0_wp        !< internal counter variable to check for instantaneous data output
+   REAL(wp) ::  time_dosurf_av           = 0.0_wp        !< internal counter variable to check for averaged data output
+
+   TYPE(surf_out) ::  surfaces  !< variable which contains all required output information
 
    SAVE
